/* lib/des/spr.h */
/* Copyright (C) 1995 Eric Young (eay@mincom.oz.au)
 * All rights reserved.
 * 
 * This file is part of an SSL implementation written
 * by Eric Young (eay@mincom.oz.au).
 * The implementation was written so as to conform with Netscapes SSL
 * specification.  This library and applications are
 * FREE FOR COMMERCIAL AND NON-COMMERCIAL USE
 * as long as the following conditions are aheared to.
 * 
 * Copyright remains Eric Young's, and as such any Copyright notices in
 * the code are not to be removed.  If this code is used in a product,
 * Eric Young should be given attribution as the author of the parts used.
 * This can be in the form of a textual message at program startup or
 * in documentation (online or textual) provided with the package.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by Eric Young (eay@mincom.oz.au)
 * 
 * THIS SOFTWARE IS PROVIDED BY ERIC YOUNG ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 * The licence and distribution terms for any publically available version or
 * derivative of this code cannot be changed.  i.e. this code cannot simply be
 * copied and put under another distribution licence
 * [including the GNU Public Licence.]
 */

static const unsigned long des_SPtrans[8][64]={
{
/* nibble 0 */
0x00820200LU, 0x00020000LU, 0x80800000LU, 0x80820200LU,
0x00800000LU, 0x80020200LU, 0x80020000LU, 0x80800000LU,
0x80020200LU, 0x00820200LU, 0x00820000LU, 0x80000200LU,
0x80800200LU, 0x00800000LU, 0x00000000LU, 0x80020000LU,
0x00020000LU, 0x80000000LU, 0x00800200LU, 0x00020200LU,
0x80820200LU, 0x00820000LU, 0x80000200LU, 0x00800200LU,
0x80000000LU, 0x00000200LU, 0x00020200LU, 0x80820000LU,
0x00000200LU, 0x80800200LU, 0x80820000LU, 0x00000000LU,
0x00000000LU, 0x80820200LU, 0x00800200LU, 0x80020000LU,
0x00820200LU, 0x00020000LU, 0x80000200LU, 0x00800200LU,
0x80820000LU, 0x00000200LU, 0x00020200LU, 0x80800000LU,
0x80020200LU, 0x80000000LU, 0x80800000LU, 0x00820000LU,
0x80820200LU, 0x00020200LU, 0x00820000LU, 0x80800200LU,
0x00800000LU, 0x80000200LU, 0x80020000LU, 0x00000000LU,
0x00020000LU, 0x00800000LU, 0x80800200LU, 0x00820200LU,
0x80000000LU, 0x80820000LU, 0x00000200LU, 0x80020200LU,
},{
/* nibble 1 */
0x10042004LU, 0x00000000LU, 0x00042000LU, 0x10040000LU,
0x10000004LU, 0x00002004LU, 0x10002000LU, 0x00042000LU,
0x00002000LU, 0x10040004LU, 0x00000004LU, 0x10002000LU,
0x00040004LU, 0x10042000LU, 0x10040000LU, 0x00000004LU,
0x00040000LU, 0x10002004LU, 0x10040004LU, 0x00002000LU,
0x00042004LU, 0x10000000LU, 0x00000000LU, 0x00040004LU,
0x10002004LU, 0x00042004LU, 0x10042000LU, 0x10000004LU,
0x10000000LU, 0x00040000LU, 0x00002004LU, 0x10042004LU,
0x00040004LU, 0x10042000LU, 0x10002000LU, 0x00042004LU,
0x10042004LU, 0x00040004LU, 0x10000004LU, 0x00000000LU,
0x10000000LU, 0x00002004LU, 0x00040000LU, 0x10040004LU,
0x00002000LU, 0x10000000LU, 0x00042004LU, 0x10002004LU,
0x10042000LU, 0x00002000LU, 0x00000000LU, 0x10000004LU,
0x00000004LU, 0x10042004LU, 0x00042000LU, 0x10040000LU,
0x10040004LU, 0x00040000LU, 0x00002004LU, 0x10002000LU,
0x10002004LU, 0x00000004LU, 0x10040000LU, 0x00042000LU,
},{
/* nibble 2 */
0x41000000LU, 0x01010040LU, 0x00000040LU, 0x41000040LU,
0x40010000LU, 0x01000000LU, 0x41000040LU, 0x00010040LU,
0x01000040LU, 0x00010000LU, 0x01010000LU, 0x40000000LU,
0x41010040LU, 0x40000040LU, 0x40000000LU, 0x41010000LU,
0x00000000LU, 0x40010000LU, 0x01010040LU, 0x00000040LU,
0x40000040LU, 0x41010040LU, 0x00010000LU, 0x41000000LU,
0x41010000LU, 0x01000040LU, 0x40010040LU, 0x01010000LU,
0x00010040LU, 0x00000000LU, 0x01000000LU, 0x40010040LU,
0x01010040LU, 0x00000040LU, 0x40000000LU, 0x00010000LU,
0x40000040LU, 0x40010000LU, 0x01010000LU, 0x41000040LU,
0x00000000LU, 0x01010040LU, 0x00010040LU, 0x41010000LU,
0x40010000LU, 0x01000000LU, 0x41010040LU, 0x40000000LU,
0x40010040LU, 0x41000000LU, 0x01000000LU, 0x41010040LU,
0x00010000LU, 0x01000040LU, 0x41000040LU, 0x00010040LU,
0x01000040LU, 0x00000000LU, 0x41010000LU, 0x40000040LU,
0x41000000LU, 0x40010040LU, 0x00000040LU, 0x01010000LU,
},{
/* nibble 3 */
0x00100402LU, 0x04000400LU, 0x00000002LU, 0x04100402LU,
0x00000000LU, 0x04100000LU, 0x04000402LU, 0x00100002LU,
0x04100400LU, 0x04000002LU, 0x04000000LU, 0x00000402LU,
0x04000002LU, 0x00100402LU, 0x00100000LU, 0x04000000LU,
0x04100002LU, 0x00100400LU, 0x00000400LU, 0x00000002LU,
0x00100400LU, 0x04000402LU, 0x04100000LU, 0x00000400LU,
0x00000402LU, 0x00000000LU, 0x00100002LU, 0x04100400LU,
0x04000400LU, 0x04100002LU, 0x04100402LU, 0x00100000LU,
0x04100002LU, 0x00000402LU, 0x00100000LU, 0x04000002LU,
0x00100400LU, 0x04000400LU, 0x00000002LU, 0x04100000LU,
0x04000402LU, 0x00000000LU, 0x00000400LU, 0x00100002LU,
0x00000000LU, 0x04100002LU, 0x04100400LU, 0x00000400LU,
0x04000000LU, 0x04100402LU, 0x00100402LU, 0x00100000LU,
0x04100402LU, 0x00000002LU, 0x04000400LU, 0x00100402LU,
0x00100002LU, 0x00100400LU, 0x04100000LU, 0x04000402LU,
0x00000402LU, 0x04000000LU, 0x04000002LU, 0x04100400LU,
},{
/* nibble 4 */
0x02000000LU, 0x00004000LU, 0x00000100LU, 0x02004108LU,
0x02004008LU, 0x02000100LU, 0x00004108LU, 0x02004000LU,
0x00004000LU, 0x00000008LU, 0x02000008LU, 0x00004100LU,
0x02000108LU, 0x02004008LU, 0x02004100LU, 0x00000000LU,
0x00004100LU, 0x02000000LU, 0x00004008LU, 0x00000108LU,
0x02000100LU, 0x00004108LU, 0x00000000LU, 0x02000008LU,
0x00000008LU, 0x02000108LU, 0x02004108LU, 0x00004008LU,
0x02004000LU, 0x00000100LU, 0x00000108LU, 0x02004100LU,
0x02004100LU, 0x02000108LU, 0x00004008LU, 0x02004000LU,
0x00004000LU, 0x00000008LU, 0x02000008LU, 0x02000100LU,
0x02000000LU, 0x00004100LU, 0x02004108LU, 0x00000000LU,
0x00004108LU, 0x02000000LU, 0x00000100LU, 0x00004008LU,
0x02000108LU, 0x00000100LU, 0x00000000LU, 0x02004108LU,
0x02004008LU, 0x02004100LU, 0x00000108LU, 0x00004000LU,
0x00004100LU, 0x02004008LU, 0x02000100LU, 0x00000108LU,
0x00000008LU, 0x00004108LU, 0x02004000LU, 0x02000008LU,
},{
/* nibble 5 */
0x20000010LU, 0x00080010LU, 0x00000000LU, 0x20080800LU,
0x00080010LU, 0x00000800LU, 0x20000810LU, 0x00080000LU,
0x00000810LU, 0x20080810LU, 0x00080800LU, 0x20000000LU,
0x20000800LU, 0x20000010LU, 0x20080000LU, 0x00080810LU,
0x00080000LU, 0x20000810LU, 0x20080010LU, 0x00000000LU,
0x00000800LU, 0x00000010LU, 0x20080800LU, 0x20080010LU,
0x20080810LU, 0x20080000LU, 0x20000000LU, 0x00000810LU,
0x00000010LU, 0x00080800LU, 0x00080810LU, 0x20000800LU,
0x00000810LU, 0x20000000LU, 0x20000800LU, 0x00080810LU,
0x20080800LU, 0x00080010LU, 0x00000000LU, 0x20000800LU,
0x20000000LU, 0x00000800LU, 0x20080010LU, 0x00080000LU,
0x00080010LU, 0x20080810LU, 0x00080800LU, 0x00000010LU,
0x20080810LU, 0x00080800LU, 0x00080000LU, 0x20000810LU,
0x20000010LU, 0x20080000LU, 0x00080810LU, 0x00000000LU,
0x00000800LU, 0x20000010LU, 0x20000810LU, 0x20080800LU,
0x20080000LU, 0x00000810LU, 0x00000010LU, 0x20080010LU,
},{
/* nibble 6 */
0x00001000LU, 0x00000080LU, 0x00400080LU, 0x00400001LU,
0x00401081LU, 0x00001001LU, 0x00001080LU, 0x00000000LU,
0x00400000LU, 0x00400081LU, 0x00000081LU, 0x00401000LU,
0x00000001LU, 0x00401080LU, 0x00401000LU, 0x00000081LU,
0x00400081LU, 0x00001000LU, 0x00001001LU, 0x00401081LU,
0x00000000LU, 0x00400080LU, 0x00400001LU, 0x00001080LU,
0x00401001LU, 0x00001081LU, 0x00401080LU, 0x00000001LU,
0x00001081LU, 0x00401001LU, 0x00000080LU, 0x00400000LU,
0x00001081LU, 0x00401000LU, 0x00401001LU, 0x00000081LU,
0x00001000LU, 0x00000080LU, 0x00400000LU, 0x00401001LU,
0x00400081LU, 0x00001081LU, 0x00001080LU, 0x00000000LU,
0x00000080LU, 0x00400001LU, 0x00000001LU, 0x00400080LU,
0x00000000LU, 0x00400081LU, 0x00400080LU, 0x00001080LU,
0x00000081LU, 0x00001000LU, 0x00401081LU, 0x00400000LU,
0x00401080LU, 0x00000001LU, 0x00001001LU, 0x00401081LU,
0x00400001LU, 0x00401080LU, 0x00401000LU, 0x00001001LU,
},{
/* nibble 7 */
0x08200020LU, 0x08208000LU, 0x00008020LU, 0x00000000LU,
0x08008000LU, 0x00200020LU, 0x08200000LU, 0x08208020LU,
0x00000020LU, 0x08000000LU, 0x00208000LU, 0x00008020LU,
0x00208020LU, 0x08008020LU, 0x08000020LU, 0x08200000LU,
0x00008000LU, 0x00208020LU, 0x00200020LU, 0x08008000LU,
0x08208020LU, 0x08000020LU, 0x00000000LU, 0x00208000LU,
0x08000000LU, 0x00200000LU, 0x08008020LU, 0x08200020LU,
0x00200000LU, 0x00008000LU, 0x08208000LU, 0x00000020LU,
0x00200000LU, 0x00008000LU, 0x08000020LU, 0x08208020LU,
0x00008020LU, 0x08000000LU, 0x00000000LU, 0x00208000LU,
0x08200020LU, 0x08008020LU, 0x08008000LU, 0x00200020LU,
0x08208000LU, 0x00000020LU, 0x00200020LU, 0x08008000LU,
0x08208020LU, 0x00200000LU, 0x08200000LU, 0x08000020LU,
0x00208000LU, 0x00008020LU, 0x08008020LU, 0x08200000LU,
0x00000020LU, 0x08208000LU, 0x00208020LU, 0x00000000LU,
0x08000000LU, 0x08200020LU, 0x00008000LU, 0x00208020LU,
}};
